package uy.edu.fing.tse.practico.db.entity;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;

@Entity
@NamedQueries({
        @NamedQuery(name = "Noticia.findAll", query = "select n from Noticia n"),
        @NamedQuery(name = "Noticia.findById", query = "select n from Noticia n where n.id = :id")
})
public class Noticia {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;

    private String titulo;

    private String descripcion;

    @OneToMany(fetch = FetchType.LAZY, cascade = CascadeType.ALL, mappedBy = "noticia", orphanRemoval = true)
    private List<Publicacion> publicaciones = new ArrayList<>();

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getTitulo() {
        return titulo;
    }

    public void setTitulo(String titulo) {
        this.titulo = titulo;
    }

    public String getDescripcion() {
        return descripcion;
    }

    public void setDescripcion(String descripcion) {
        this.descripcion = descripcion;
    }

    public List<Publicacion> getPublicaciones() {
        return publicaciones;
    }

    public void addPublicacion(Publicacion p) {
        p.setNoticia(this);
        this.publicaciones.add(p);
    }

    public void setPublicaciones(List<Publicacion> publicaciones) {
        publicaciones.forEach(p -> {
            if (p.getNoticia() == null) {
                p.setNoticia(this);
            }
        });
        this.publicaciones = publicaciones;
    }
}
