package uy.edu.fing.tse.practico.db.mapper;

import uy.edu.fing.tse.dto.NoticiaDTO;
import uy.edu.fing.tse.dto.PublicacionDTO;
import uy.edu.fing.tse.practico.db.entity.Noticia;
import uy.edu.fing.tse.practico.db.entity.Publicacion;

import java.util.stream.Collectors;

public final class Mapper {
    private Mapper() {
    }

    public static Publicacion mapper(final PublicacionDTO p) {
        Publicacion ret = new Publicacion();
        ret.setId(p.getId());
        ret.setTipo(p.getTipo());
        ret.setUrl(p.getUrl());
        return ret;
    }

    public static PublicacionDTO mapper(final Publicacion p) {
        return new PublicacionDTO(p.getId(), p.getTipo(), p.getUrl());
    }

    public static Noticia mapper(final NoticiaDTO n) {
        Noticia ret = new Noticia();
        ret.setTitulo(n.getTitulo());
        ret.setDescripcion(n.getDescripcion());
        n.getPublicaciones().stream().map(Mapper::mapper).forEach(ret::addPublicacion);
        return ret;
    }

    public static NoticiaDTO mapper(final Noticia n) {
        final NoticiaDTO dao = new NoticiaDTO(n.getId(), n.getTitulo(), n.getDescripcion());
        dao.setPublicaciones(n.getPublicaciones()
                .stream().map(Mapper::mapper)
                .collect(Collectors.toList()));
        return dao;
    }

    public static void update(final PublicacionDTO p, Publicacion dbP) {
        dbP.setTipo(p.getTipo());
        dbP.setUrl(p.getUrl());
    }

    public static void update(final NoticiaDTO n, Noticia dbN) {
        dbN.setTitulo(n.getTitulo());
        dbN.setDescripcion(n.getDescripcion());
        //FIXME puede dar inconsistencia
        n.getPublicaciones().stream().map(Mapper::mapper).forEach(dbN::addPublicacion);
    }
}
