package uy.edu.fing.tse.dto;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public final class NoticiaDTO implements Serializable {


    private static final long serialVersionUID = 4516690446335921631L;

    private final Long id;

    private final String titulo;

    private final String descripcion;

    private final List<PublicacionDTO> publicaciones = new ArrayList<>();

    public NoticiaDTO(Long id, String titulo, String descripcion) {
        this.id = id;
        this.titulo = titulo;
        this.descripcion = descripcion;
    }

    public Long getId() {
        return id;
    }


    public String getTitulo() {
        return titulo;
    }


    public String getDescripcion() {
        return descripcion;
    }

    public List<PublicacionDTO> getPublicaciones() {
        return publicaciones;
    }

    public void setPublicaciones(List<PublicacionDTO> publicaciones) {
        this.publicaciones.clear();
        this.publicaciones.addAll(publicaciones);
    }

    @Override
    public String toString() {
        return "NoticiaDTO{" +
                "id=" + id +
                ", titulo='" + titulo + '\'' +
                ", descripcion='" + descripcion + '\'' +
                ", publicaciones=" + publicaciones +
                '}';
    }
}
