package uy.edu.fing.tse.practico.business;


import uy.edu.fing.tse.dto.NoticiaDTO;
import uy.edu.fing.tse.dto.PublicacionDTO;
import uy.edu.fing.tse.practico.db.DataAccessBean;

import javax.annotation.PostConstruct;
import javax.ejb.*;
import java.util.List;

/**
 * Se debe controlar que una noticia no tenga más de diez publicaciones. Esta
 * capa deberá implementarse con Stateless Session Beans que provean interfaces
 * remotas y locales
 */
@Stateless
@Local({BusinessLocal.class})
@Remote({BusinessRemote.class})
@LocalBean
public class BusinessBean implements BusinessLocal, BusinessRemote {

    @EJB
    private DataAccessBean dataAccess;

    @PostConstruct
    void init() {
        //Despues Hace esto
    }

    @Override
    public void add(NoticiaDTO noticia) {
        dataAccess.alta(noticia);
    }

    @Override
    public void add(PublicacionDTO publicacion, NoticiaDTO noticia) {
        noticia.getPublicaciones().add(publicacion);
        dataAccess.alta(noticia);
    }

    @Override
    public NoticiaDTO findNoticia(final long idNoticia) {
        return dataAccess.find(idNoticia);
    }

    @Override
    public List<NoticiaDTO> getNoticias() {
        return dataAccess.getNoticias();
    }

    @Override
    public List<PublicacionDTO> getPublicaciones() {
        return dataAccess.getPublicaciones();
    }

    @Override
    public List<PublicacionDTO> getPublicaciones(final long idNoticia) {
        return dataAccess.find(idNoticia).getPublicaciones();
    }

    @Override
    public NoticiaDTO addPublicacionANoticia(final PublicacionDTO pub, final long idNoticia) {
        NoticiaDTO noticiaDTO = dataAccess.find(idNoticia);

        if (noticiaDTO.getPublicaciones().size() >= 10) {
            throw new RuntimeException("La noticia tiene demasiadas publicaciones ya.");
        }

        noticiaDTO = dataAccess.addPublicacionToNoticia(pub, idNoticia);
        return noticiaDTO;
    }
}
