package uy.edu.fing.tse.practico.business.jms;

import uy.edu.fing.tse.dto.NoticiaDTO;
import uy.edu.fing.tse.practico.business.BusinessBean;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.EJB;
import javax.ejb.MessageDriven;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;

//FIXME comentarlo para el despliegue en OpenShift
@MessageDriven(name = "AltaNoticia", activationConfig = {
        @ActivationConfigProperty(propertyName = "destination", propertyValue = "java:/jms/queue/queue_alta_noticia"),
        @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
        @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
        @ActivationConfigProperty(propertyName = "maxSession", propertyValue = "50")
})
public class AltaNoticiaMDB implements MessageListener {

    @EJB
    private BusinessBean negocio;

    @Override
    public void onMessage(Message message) {
        try {
            final String body = message.getBody(String.class);
            final String[] split = body.trim().split("\\|");

            final NoticiaDTO noticia = new NoticiaDTO(null, split[0], split[1]);
            negocio.add(noticia);

        } catch (JMSException e) {
            e.printStackTrace();
        }
    }
}
