package uy.edu.fing.tse.practico.business.jms;

import uy.edu.fing.tse.dto.NoticiaDTO;

import javax.annotation.Resource;
import javax.ejb.Stateless;
import javax.jms.*;

@Stateless
public class JMSProducer {

    @Resource(lookup = "java:/ConnectionFactory")
    private ConnectionFactory connectionFactory;

    @Resource(lookup = "java:/jms/queue/queue_alta_noticia")
    private Queue sendQueue;

    public void altaNoticia(final NoticiaDTO noticia) {
        try {
            sendMsj(noticia.getTitulo() + "|" + noticia.getDescripcion());
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    private void sendMsj(final String messageStr) {
        // Create the JMS connection, session, producer, and consumer
        try (Connection connection = connectionFactory.createConnection()) {
            final Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
            final MessageProducer producer = session.createProducer(sendQueue);

            connection.start();

            final Message message = session.createTextMessage(messageStr);
            producer.send(message);
        } catch (JMSException _e) {
            //ignore
        }
    }
}
